/*                      LEKCJA07.C
//---------------------------------------------------------------------------
Temat:
        Definiowanie elementu TEKST
//---------------------------------------------------------------------------
Funkcja:
        EXT(213) void GetTextVal(      
//---------------------------------------------------------------------------

   Wprowadzanie tekstu do rysunku na pozr wydaje si niezwykle skomplikowane
   ze wzgldu na ilo zmiennych w peni definiujcych typ T_TEXT. Jednake 
   w praktyce wykorzystuje si zazwyczaj standardowo zdefiniowane wartoci.
   Ogromnie uatwia prac skorzystanie z funkcji 'GetTextVal' opisanej w 
   nastpnym rozdziale. W pliku 'MEGATYP.H' zdefiniowana jest struktura 
   budowy typu  't_text'

typedef struct _text
{
    t_txtval val;        // atrybuty tekstu
    t_txtfnt fnt;        // font tekstu
    double   tx;         // wsprzdna X pocztku tekstu
    double   ty;         // wsprzdna Y pocztku tekstu 
    double   dx1;        // wektor podstawy warto X
    double   dy1;        // wektor podstawy warto Y
    double   dx2;        // wektor pochylenia warto X 
    double   dy2;        // wektor pochylenia warto Y
    ushort   numl;       // ilo linijek tekstu
    char     _far *str;  // tekst
} t_text;

typedef struct _txtval
{
    double w1;           // kt liter
    double w2;           // kt linii tekstowej
    double dx;           // szeroko liter
    double dy;           // wysoko liter
    double sx;           // szeroko odstpu midzy literami
    double ld;           // odstp midzy liniami tekstu
} t_txtval;

typedef struct _txtfnt
{
    uchar name[32];       // nazwa TRUETYPE, nazwa pliku z fontem wektorowym
    uchar CharSet;        // warto - opis dalej
    uchar PitchAndFamily; // warto - opis dalej
    uchar System;         // warto - opis dalej
    uchar Attribs;        // warto - opis dalej
} t_txtfnt;


// wartoci zmiennej 'System' 
#define GT_TRUETYPE      0
#define GT_VECTOR        1

// wartoci zmiennej 'PitchAndFamily'
#define GT_FFDONTCARE    0x00
#define GT_ROMAN         0x10
#define GT_SWISS         0x20
#define GT_MODERN        0x30
#define GT_SCRIPT        0x40
#define GT_DECORATIVE    0x50

#define GT_FIXED         0x01
#define GT_VARIABLE      0x02

// wartoci zmiennej 'CharSet'
#define GT_ANSI          0
#define GT_SYMBOL        2
#define GT_ASIAN         3
#define GT_OEM           255

// wartoci zmiennej 'Attribs' bity
#define GT_ITALIC        (1<<0)
#define GT_STRIKEOUT     (1<<1)
#define GT_UNDERLINE     (1<<2)
#define GT_BOLD          (1<<3)
#define GT_ISDOWN        (1<<4)
//---------------------------------------------------------------------------

   Nastpnym uatwieniem przy definiowaniu tekstu jest funkcja 'GetTextVal'
   wczytujca aktualnie ustawione parametry tekstu 

EXT(213) void GetTextVal(      // 
             ushort type,      // linia tekstu lub blok tekstowy
             ushort init,      // inicjalizacja TRUE
                               // tylko policzenie prostokta FALSE
             t_text *txt);     // dane tekstu

*/
//---------------------------------------------------------------------------
#include "std.h"
#include "megatyp.h"
#include "megacad.h"
//---------------------------------------------------------------------------
int DrwTxt(void *para)
{
    t_text  *txtdata;
    txtdata = para;
    DrawInv(E_TXTLIN,txtdata,LMODE(0,PIX_XOR,0,0),E_TXTLIN);
    return(0);
}
//---------------------------------------------------------------------------
short main(char *filename, char *args)
{
    t_text  txtdata;
    char    str[255];
    SetFuncText("wpisywanie tekstu");
    if(StringInput("Podanie linii tekstu",str,255))
    {
        txtdata.str = str;
        GetTextVal(E_TXTLIN,TRUE,&txtdata);
        SetFuncText("wstawianie tekstu");
        MouseHelp("umie tekst","powrt",HLP_INV(0,0,0));
        if(GetPntInv(&txtdata.tx,0,DrwTxt,&txtdata))
        {
            CreateEntity(E_TXTLIN,NULL,&txtdata);
            savecount();
        }
    }
}
//---------------------------------------------------------------------------
